
public class List implements Cloneable {

    private Object a; // allgemeine Daten
    private List d;   // Referenz auf das nchste ELement

    /**
     * Der Konstruktor und alle Objekt-Methoden sind nicht 
     * ffentlich.
     */
    protected List(Object ap, List dp) {
	a = ap; d = dp; 
    }

    protected Object car() { return a; }
    protected List cdr() { return d; }

    protected void setcar(Object ap) { a = ap; }
    protected void setcdr(List dp) { d = dp; }


    /**
     * Nur die Klassen-Methoden sind ffentlich.
     */
    public static List cons(Object a, List d) {
	return new List(a,d);
    }

    public static Object car(List n) {
	//if ( n == null ) return null;
	return n.car();
    }

    public static List cdr(List n) {
	//if ( n == null ) return null;
	return n.cdr();
    }

    public static void setcar(List n, Object a) {
	//if ( n == null ) return;
	n.setcar(a);
    }

    public static void setcdr(List n, List d) {
	//if ( n == null ) return;
	n.setcdr(d);
    }

    public String toString() {
	String s = "(";
	List t = this;
	Object a;
	for (;;) { 
            a = t.car();
	    if ( a == null ) s += "null";
	    else s += a.toString();
	    if ( t.cdr() != null ) {
               s += " ";
               t = t.cdr();
            } else break;
	}
	s += ")";
	return s;
    }


    protected List append(List dp) { 
	if ( d == null ) return cons( a, dp );
	List t;
	if ( d.cdr() == null ) t = cons( d.car(), dp);
	else t = cons( d.car(), d.cdr().append( dp ) );
	return cons(a, t);
    }

    public static List append(List x, List y) {
	if ( x == null ) return y;
	return x.append(y);
    }


    protected Object ncar(int j) { 
	List t = this;
	for (int i = 0; i < j; i++ ) {
	    t = t.cdr();
            if ( t == null ) return null;
	}
	return t.car();
    }

    public static Object ncar(List n, int j) {
        if ( n == null ) return null;
	return n.ncar(j);
    }

    protected int length() { 
	int l = 1;
	List t = this;
	while ( t.cdr() != null ) {
	    t = t.cdr();
	    l++;
	}
	return l;
    }

    public static int length(List n) {
        if ( n == null ) return 0;
	return n.length();
    }


    protected List reverse() { 
	if ( d == null ) return this;
        return append( d.reverse(), cons( a, null) );
    }

    public static List reverse(List n) {
        if ( n == null ) return n;
	return n.reverse();
    }

    public Object clone() { 
	Object ap = a;
	if ( a != null && a instanceof List ) ap = ((List)a).clone();
	if ( d == null ) return cons( ap, d );
	return cons( ap, (List)d.clone() );
    }

    public static Object clone(List n) {
        if ( n == null ) return n;
	return n.clone();
    }

    public boolean equals(Object np) { 
	if ( this == np ) return true;
	if ( np == null ) return false;
	if ( !(np instanceof List) ) return false;
	List n = (List) np;
	if ( a == null ) {
           if ( n.car() != null ) return false;
	} else {
           if ( ! a.equals( n.car() ) ) return false;
	}
	if ( d == null ) return n.cdr() == null;
	return d.equals( n.cdr() );
    }

    public static boolean equals(List a, Object b) {
        if ( a == null ) return b == null;
	return a.equals(b);
    }

}
