
/**
  * Testen einer einfachen Ein- und Ausgabe
  * Eingabe von einer ObjectStream-Datei
  * Ausgabe auf eine ObjectStream-Datei
  * hk, 15.12.2001
 **/ 

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.OptionalDataException;


public class Objekte {

    public static void main(String[] args) {

        Screen sc = new Screen();
        KeyBoard kb = new KeyBoard();
        final int MAX = 100; 
        String[] data = null;

        if ( args.length < 1 ) {
            sc.println("Usage: Dateien <speicher datei>");
            return;
        }

        ObjectEin rein = null;
        ObjectAus raus;

        try {
            rein = new ObjectEin(args[0]);
        }
        catch (FileNotFoundException e) {
            sc.println("Die Datei " + args[0] + " existiert nicht.");
        }
        catch (IOException e) {
            sc.println("Die Datei " + args[0] + " nicht lesbar.");
        }

        if ( rein != null ) {
            try {
                 data = (String[]) rein.readObject();
                 rein.close();
            }
            catch (OptionalDataException e) {
                 sc.println("Zuviel Daten in Datei " + args[0]);
            }
            catch (ClassNotFoundException e) {
                 sc.println("Zu lesende Klasse nicht bekannt in Datei " + args[0]+ ": "+e);
            }
            catch (IOException e) {
                 sc.println("Lesefehler von Datei " + args[0]);
            }
        } 

        if ( data == null ) {
            data = new String[MAX];
        }

        try {
            raus = new ObjectAus(args[0]);
        }
        catch (IOException e) {
            sc.println("Die Datei " + args[0] + " ist nicht beschreibbar.");
            return;
        }


        String ea = "";
        int zeile = -1; // leer
        int ein = 0;
        int aus = 0;

        sc.println("Aktueller Inhalt von " + args[0]);
        for ( zeile = 0; zeile < MAX; zeile++ ) {
            if ( data[zeile] == null ) break;
            sc.println("" + zeile + ": " + data[zeile] );
        }
        // zeile zeigt jetzt auf einen freien Platz in data
        zeile--;
        sc.println(""+(zeile+1)+" Zeilen in " + args[0] + " enthalten\n");

        try {
            sc.println(  "Beenden mit 'ende'");
            do {
                sc.print(  "Bitte um Eingabe: ");
                sc.flush();
                ea = kb.readLine(); 
                if ( ea == null ) break; 
                if ( ea.equals("ende") ) break;
                ein++;
                sc.println("Eingabe: "+(zeile+1)+": " +ea);
                zeile++; 
                if ( zeile < MAX ) data[zeile] = ea; 
                aus++;
            } while (true);
        } 
        catch (IOException e) {
            e.printStackTrace();
        }
        finally {
            try {
                raus.writeObject(data);
                raus.close();
            }
            catch (IOException e) {
                sc.println("Fehler beim Schreiben auf Die Datei " + args[0]);
            }
        }

        sc.println();
        sc.println(""+ein+" Zeile(n) von der Tastatur gelesen");
        sc.println(""+aus+" Zeile(n) auf den Bildschirm geschrieben");
        sc.println(""+(zeile+1)+" Zeile(n) nach " + args[0] + " geschrieben");
    }

}
