import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document; 
import org.w3c.dom.Node; 
import org.w3c.dom.Element; 
import java.io.IOException;
import org.xml.sax.SAXException;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;


public class Bestellung {

    public static void main(String[] args) {

	Screen sc = new Screen();
	if (args.length < 3) {
	    sc.println("Usage: Bestellung" +
                       " <lagerdatei.xml>" +
                       " <bestellung.xml>" +
                       " <lieferung.xml>");
            return;
	}

	// Lager einlesen: 
	DocumentBuilderFactory lpfac = DocumentBuilderFactory.newInstance();
	DocumentBuilder lparser = null;

	try {
	   lpfac.setValidating(true);
	   lparser = lpfac.newDocumentBuilder();
	}
	catch (ParserConfigurationException e) {
	    e.printStackTrace();
	}

	Document lager = null;
        String lauri = args[0];

	try {
            lager = lparser.parse(lauri);
	}
	catch (SAXException e) {
	    e.printStackTrace();
	}
	catch (IOException e) {
	    e.printStackTrace();
	}


	// Bestellung einlesen und Lieferschein schreiben: 
	SAXParserFactory bpfac = SAXParserFactory.newInstance();
	SAXParser bparser = null;

	try {
	   bpfac.setValidating(true);
	   bpfac.setNamespaceAware(true);
	   bparser = bpfac.newSAXParser();
	}
	catch (ParserConfigurationException e) {
	    e.printStackTrace();
	}
	catch (SAXException e) {
	    e.printStackTrace();
	}

        String buri = args[1];
        String liuri = args[2];
        DateiAus lid = null;
	try {
            lid = new DateiAus(liuri);
	}
	catch (IOException e) {
            sc.println("Fehler Ausgabedatei "+liuri);
            e.printStackTrace();
        }

	DOMLager domLager = new DOMLager(lager); 
	DefaultHandler dh = new SAXBestellung(lid,domLager);
	try {
            bparser.parse(buri,dh);
	}
	catch (SAXException e) {
	    e.printStackTrace();
	}
	catch (IOException e) {
	    e.printStackTrace();
	}

	// Lager sichern
	DateiAus lad = null;
	try {
	    lad = new DateiAus(lauri+"~");
	}
	catch (IOException e) {
            sc.println("Fehler Ausgabedatei " + lauri+"~" );
            e.printStackTrace();
        }
        DOMSchreiber ls = new DOMSchreiber(lad);
        ls.printNode(lager);
        ls.flush();
        ls.close();

    }

}
