

import org.w3c.dom.Document; 
import org.w3c.dom.Node; 
import org.w3c.dom.NodeList; 
import org.w3c.dom.NamedNodeMap; 
import org.w3c.dom.Element; 
import org.w3c.dom.Text; 
import org.w3c.dom.Comment; 
import org.w3c.dom.EntityReference; 
import org.w3c.dom.DocumentType; 
import java.io.IOException;
import java.io.PrintWriter;
import org.xml.sax.SAXException;


public class WertSchreiber {

    PrintWriter pw = null;

    public WertSchreiber() {
	pw = new Screen();
    }

    public WertSchreiber(PrintWriter p) {
	pw = p;
    }


    public void print(Document doc) {
        double betrag = 0.0;
        Element art = null;

        Element d = doc.getDocumentElement();
        NodeList nl = d.getElementsByTagName("artikel"); 
        int l = nl.getLength();
	for (int i = 0; i < l; i++ ){
	    art = (Element)nl.item(i);
            betrag += getBestand(art) * getPreis(art,"EUR") ;
	}

        pw.println("\n<wert >");
        pw.println("<preis einheit=\"EUR\">" + betrag + "</preis>");
        pw.println("</wert>");
    }


    public double getPreis(Element art, String einheit) {
        NodeList pl = art.getElementsByTagName("preis"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        Text t = (Text) pr.getFirstChild();  
        String s = t.getNodeValue(); 
        double b = Double.parseDouble(s);
        String c = pr.getAttribute("einheit");
        if ( !einheit.equals(c) ) {
	    pw.println("Whrung umrechnen von "+c+" nach "+einheit);
	}
        return b;
    }

    public long  getBestand(Element art) {
        NodeList pl = art.getElementsByTagName("bestand"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        Text t = (Text) pr.getFirstChild();  
        String s = t.getNodeValue(); 
        long z = Long.parseLong(s);
        return z;
    }



    public void flush() {
	pw.flush();
    }


    public void close() {
	pw.close();
    }

}
